# nng_tls_config_cert_key_file(3tls) Manual Page

## NAME

nng_tls_config_cert_key_file - load own certificate and key from file

## SYNOPSIS

    #include <nng/nng.h>
    #include <nng/supplemental/tls/tls.h>

    int nng_tls_config_cert_key_file(nng_tls_config *cfg, const char *path,
        const char *pass);

## DESCRIPTION

The `nng_tls_config_cert_key_file()` function loads a certificate (or certificate chain) and a private key from the file named by path.

The file must contain both the PEM encoded certificate and associated private key, which will be used when establishing TLS sessions using cfg. It may contain additional certificates leading to a validation chain, with the leaf certificate first. There is no need to include the self-signed root, as the peer will need to have that already in order to perform its own validation.

The private key may be encrypted with a password, in which can be supplied in pass. The value `NULL` should be supplied for pass if the key is not encrypted.

On servers, it is possible to call this function multiple times for the same configuration. This can be useful for specifying different parameters to be used for different cryptographic algorithms.

## RETURN VALUES

This function returns 0 on success, and non-zero otherwise.

## ERRORS

`NNG_ENOMEM` | Insufficient memory is available.
`NNG_EBUSY` | The configuration cfg is already in use, and cannot be modified.
`NNG_EINVAL` | The contents of path are invalid.
`NNG_ENOENT` | The file named by path does not exist.
`NNG_EPERM` | The file named by path cannot be opened.

## SEE ALSO

nng_strerror(3), nng_tls_config_alloc(3tls), nng_tls_config_own_cert(3tls), nng(7)